// /* **********************************************************************************
//  *
//  * Copyright (c) Sky Sanders. All rights reserved.
//  * 
//  * This source code is subject to terms and conditions of the Microsoft Public
//  * License (Ms-PL). A copy of the license can be found in the license.htm file
//  * included in this distribution.
//  *
//  * You must not remove this notice, or any other, from this software.
//  *
//  * **********************************************************************************/
using System.Configuration;

namespace SimpleRemoteControl.Configuration
{
    [ConfigurationCollection(typeof (BrowserElement), AddItemName = "browser",
        CollectionType = ConfigurationElementCollectionType.BasicMap)]
    public class BrowserElementCollection : ConfigurationElementCollection
    {
        public new BrowserElement this[string id]
        {
            get { return (BrowserElement) BaseGet(id); }
        }

        protected override ConfigurationElement CreateNewElement()
        {
            return new BrowserElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return ((BrowserElement) element).Key;
        }
    }
}