﻿// <copyright project="Salient.SqlServer.FluentNHibernate" file="HierarchyIdUserTypeConvention.cs" company="Sky Sanders">
// This source is a Public Domain Dedication.
// Please see http://spikes.codeplex.com/ for details.   
// Attribution is appreciated
// </copyright> 
// <version>1.0</version>

using FluentNHibernate.Conventions;
using FluentNHibernate.Conventions.AcceptanceCriteria;
using FluentNHibernate.Conventions.Inspections;
using FluentNHibernate.Conventions.Instances;
using Salient.SqlServer.NHibernate;
using Salient.SqlServer.Types;

namespace Salient.SqlServer.FluentNHibernate
{
    /// <summary>
    /// This class is a NO-GO.
    /// 
    /// TODO: try implementing the Usertype by getting a string from the reader
    /// 
    /// SqlHierarchyId is only Binary Serializable. NH chokes on it
    /// Could implement a wrapper
    /// </summary>
    public class HierarchyIdUserTypeConvention : UserTypeConvention<HierarchyIdUserType>
    {
        public override void Accept(IAcceptanceCriteria<IPropertyInspector> criteria)
        {
            criteria.Expect(x => x.Property.PropertyType == typeof (HierarchyId));
        }

        public override void Apply(IPropertyInstance instance)
        {
            instance.CustomType(typeof (HierarchyIdUserType));
        }
    }
}