﻿// <copyright project="Salient.SqlServer.FluentNHibernate" file="XmlDocumentUserTypeConvention.cs" company="Sky Sanders">
// This source is a Public Domain Dedication.
// Please see http://spikes.codeplex.com/ for details.   
// Attribution is appreciated
// </copyright> 
// <version>1.0</version>

using System.Xml;
using FluentNHibernate.Conventions;
using FluentNHibernate.Conventions.AcceptanceCriteria;
using FluentNHibernate.Conventions.Inspections;
using FluentNHibernate.Conventions.Instances;
using Salient.SqlServer.NHibernate;

namespace Salient.SqlServer.FluentNHibernate
{
    public class XmlDocumentUserTypeConvention : UserTypeConvention<XmlDocumentUserType>
    {
        public override void Accept(IAcceptanceCriteria<IPropertyInspector> criteria)
        {
            criteria.Expect(x => x.Property.PropertyType == typeof (XmlDocument));
        }

        public override void Apply(IPropertyInstance instance)
        {
            instance.CustomType(typeof (XmlDocumentUserType));
        }
    }
}